# Refresh tunnel markers

fill -29 10 -33 29 10 31 green_concrete replace light_blue_concrete
fill -29 10 -33 29 10 31 green_concrete replace orange_concrete
fill -29 10 -33 29 10 31 green_concrete replace cyan_concrete
fill -29 10 -33 29 10 31 green_concrete replace red_concrete

execute if block ~00 0 ~01 green_concrete run function pacman:gameplay/phase_4/bot/enabled/direction/pacman/tunnel/intersection/south
execute if block ~01 0 ~00 green_concrete run function pacman:gameplay/phase_4/bot/enabled/direction/pacman/tunnel/intersection/east
execute if block ~00 0 ~-1 green_concrete run function pacman:gameplay/phase_4/bot/enabled/direction/pacman/tunnel/intersection/north
execute if block ~-1 0 ~00 green_concrete run function pacman:gameplay/phase_4/bot/enabled/direction/pacman/tunnel/intersection/west







# Get ghost proximity

scoreboard players set #ghost_proximity value 0
execute if entity @e[type=armor_stand,tag=ghost,tag=game,tag=!ghost_house,scores={mode=-1..0}              ,limit=1] run scoreboard players add #ghost_proximity value 1
execute if entity @e[type=armor_stand,tag=ghost,tag=game,tag=!ghost_house,scores={mode=-1..0},distance=..16,limit=1] run scoreboard players add #ghost_proximity value 1
execute if entity @e[type=armor_stand,tag=ghost,tag=game,tag=!ghost_house,scores={mode=-1..0},distance=..08,limit=1] run scoreboard players add #ghost_proximity value 1







# Process intersection markers

scoreboard players set #ghost_distance_0 value -2147483648
scoreboard players set #ghost_distance_1 value -2147483648
scoreboard players set #ghost_distance_2 value -2147483648
scoreboard players set #ghost_distance_3 value -2147483648

scoreboard players set #center_tunnel_0 value 0
scoreboard players set #center_tunnel_1 value 0
scoreboard players set #center_tunnel_2 value 0
scoreboard players set #center_tunnel_3 value 0

execute as @e[type=area_effect_cloud,tag=intersection] at @s run function pacman:gameplay/phase_4/bot/enabled/direction/pacman/intersection/marker/main







# Pellet tunnel

scoreboard players set #pellet_tunnel_0 value 0
scoreboard players set #pellet_tunnel_1 value 0
scoreboard players set #pellet_tunnel_2 value 0
scoreboard players set #pellet_tunnel_3 value 0

scoreboard players set #power_pellet_tunnel_0 value 0
scoreboard players set #power_pellet_tunnel_1 value 0
scoreboard players set #power_pellet_tunnel_2 value 0
scoreboard players set #power_pellet_tunnel_3 value 0

execute as @e[type=area_effect_cloud,tag=pellet] at @s run function pacman:gameplay/phase_4/bot/enabled/direction/pacman/intersection/tunnel/pellet







# Ghost tunnel

scoreboard players set #ghost_tunnel_0 value 0
scoreboard players set #ghost_tunnel_1 value 0
scoreboard players set #ghost_tunnel_2 value 0
scoreboard players set #ghost_tunnel_3 value 0

scoreboard players set #frightened_ghost_tunnel_0 value 0
scoreboard players set #frightened_ghost_tunnel_1 value 0
scoreboard players set #frightened_ghost_tunnel_2 value 0
scoreboard players set #frightened_ghost_tunnel_3 value 0

execute as @e[type=armor_stand,tag=ghost,tag=game,tag=!ghost_house] at @s run function pacman:gameplay/phase_4/bot/enabled/direction/pacman/intersection/tunnel/ghost/main







# Pellet distances

scoreboard players set #pellet_distance_0 value 2147483647
scoreboard players set #pellet_distance_1 value 2147483647
scoreboard players set #pellet_distance_2 value 2147483647
scoreboard players set #pellet_distance_3 value 2147483647

scoreboard players set #power_pellet_distance_0 value 2147483647
scoreboard players set #power_pellet_distance_1 value 2147483647
scoreboard players set #power_pellet_distance_2 value 2147483647
scoreboard players set #power_pellet_distance_3 value 2147483647


scoreboard players operation #input_x value = @s x
scoreboard players operation #input_z value = @s z


scoreboard players add #input_z value 1
execute positioned ~00 ~ ~01 as @e[type=area_effect_cloud,tag=pellet,sort=nearest,limit=1] run function pacman:gameplay/phase_4/bot/enabled/direction/pacman/intersection/target_tile
execute if block ~00 0 ~01 #pacman:path run function pacman:gameplay/phase_4/bot/enabled/direction/distance
execute if block ~00 0 ~01 #pacman:path run scoreboard players operation #pellet_distance_0 value = #output value
execute positioned ~00 ~ ~01 as @e[type=area_effect_cloud,tag=power_pellet,sort=nearest,limit=1] run function pacman:gameplay/phase_4/bot/enabled/direction/pacman/intersection/target_tile
execute if block ~00 0 ~01 #pacman:path run function pacman:gameplay/phase_4/bot/enabled/direction/distance
execute if block ~00 0 ~01 #pacman:path run scoreboard players operation #power_pellet_distance_0 value = #output value


scoreboard players remove #input_z value 2
execute positioned ~00 ~ ~-1 as @e[type=area_effect_cloud,tag=pellet,sort=nearest,limit=1] run function pacman:gameplay/phase_4/bot/enabled/direction/pacman/intersection/target_tile
execute if block ~00 0 ~-1 #pacman:path run function pacman:gameplay/phase_4/bot/enabled/direction/distance
execute if block ~00 0 ~-1 #pacman:path run scoreboard players operation #pellet_distance_2 value = #output value
execute positioned ~00 ~ ~-1 as @e[type=area_effect_cloud,tag=power_pellet,sort=nearest,limit=1] run function pacman:gameplay/phase_4/bot/enabled/direction/pacman/intersection/target_tile
execute if block ~00 0 ~-1 #pacman:path run function pacman:gameplay/phase_4/bot/enabled/direction/distance
execute if block ~00 0 ~-1 #pacman:path run scoreboard players operation #power_pellet_distance_2 value = #output value


scoreboard players add #input_z value 1
scoreboard players add #input_x value 1
execute positioned ~01 ~ ~00 as @e[type=area_effect_cloud,tag=pellet,sort=nearest,limit=1] run function pacman:gameplay/phase_4/bot/enabled/direction/pacman/intersection/target_tile
execute if block ~01 0 ~00 #pacman:path run function pacman:gameplay/phase_4/bot/enabled/direction/distance
execute if block ~01 0 ~00 #pacman:path run scoreboard players operation #pellet_distance_1 value = #output value
execute positioned ~01 ~ ~00 as @e[type=area_effect_cloud,tag=power_pellet,sort=nearest,limit=1] run function pacman:gameplay/phase_4/bot/enabled/direction/pacman/intersection/target_tile
execute if block ~01 0 ~00 #pacman:path run function pacman:gameplay/phase_4/bot/enabled/direction/distance
execute if block ~01 0 ~00 #pacman:path run scoreboard players operation #power_pellet_distance_1 value = #output value


scoreboard players remove #input_x value 2
execute positioned ~-1 ~ ~00 as @e[type=area_effect_cloud,tag=pellet,sort=nearest,limit=1] run function pacman:gameplay/phase_4/bot/enabled/direction/pacman/intersection/target_tile
execute if block ~-1 0 ~00 #pacman:path run function pacman:gameplay/phase_4/bot/enabled/direction/distance
execute if block ~-1 0 ~00 #pacman:path run scoreboard players operation #pellet_distance_3 value = #output value
execute positioned ~-1 ~ ~00 as @e[type=area_effect_cloud,tag=power_pellet,sort=nearest,limit=1] run function pacman:gameplay/phase_4/bot/enabled/direction/pacman/intersection/target_tile
execute if block ~-1 0 ~00 #pacman:path run function pacman:gameplay/phase_4/bot/enabled/direction/distance
execute if block ~-1 0 ~00 #pacman:path run scoreboard players operation #power_pellet_distance_3 value = #output value


scoreboard players operation #math_00 value = #pellet_distance_0 value
scoreboard players operation #math_00 value < #pellet_distance_1 value
scoreboard players operation #math_00 value < #pellet_distance_2 value
scoreboard players operation #math_00 value < #pellet_distance_3 value

scoreboard players set #pellet_distance_nearest_0 value 0
scoreboard players set #pellet_distance_nearest_1 value 0
scoreboard players set #pellet_distance_nearest_2 value 0
scoreboard players set #pellet_distance_nearest_3 value 0

execute if score #pellet_distance_0 value = #math_00 value run scoreboard players set #pellet_distance_nearest_0 value 1
execute if score #pellet_distance_1 value = #math_00 value run scoreboard players set #pellet_distance_nearest_1 value 1
execute if score #pellet_distance_2 value = #math_00 value run scoreboard players set #pellet_distance_nearest_2 value 1
execute if score #pellet_distance_3 value = #math_00 value run scoreboard players set #pellet_distance_nearest_3 value 1


scoreboard players operation #math_00 value = #power_pellet_distance_0 value
scoreboard players operation #math_00 value < #power_pellet_distance_1 value
scoreboard players operation #math_00 value < #power_pellet_distance_2 value
scoreboard players operation #math_00 value < #power_pellet_distance_3 value

scoreboard players set #power_pellet_distance_nearest_0 value 0
scoreboard players set #power_pellet_distance_nearest_1 value 0
scoreboard players set #power_pellet_distance_nearest_2 value 0
scoreboard players set #power_pellet_distance_nearest_3 value 0

execute if score #power_pellet_distance_0 value = #math_00 value run scoreboard players set #power_pellet_distance_nearest_0 value 1
execute if score #power_pellet_distance_1 value = #math_00 value run scoreboard players set #power_pellet_distance_nearest_1 value 1
execute if score #power_pellet_distance_2 value = #math_00 value run scoreboard players set #power_pellet_distance_nearest_2 value 1
execute if score #power_pellet_distance_3 value = #math_00 value run scoreboard players set #power_pellet_distance_nearest_3 value 1







# Apply scores

scoreboard players set #score_0 value 0
scoreboard players set #score_1 value 0
scoreboard players set #score_2 value 0
scoreboard players set #score_3 value 0



# Wall

execute if block ~00 0 ~01 #pacman:path run scoreboard players add #score_0 value 8192
execute if block ~01 0 ~00 #pacman:path run scoreboard players add #score_1 value 8192
execute if block ~00 0 ~-1 #pacman:path run scoreboard players add #score_2 value 8192
execute if block ~-1 0 ~00 #pacman:path run scoreboard players add #score_3 value 8192



# Ghost tunnel

execute if score #ghost_tunnel_0 value matches 0 run scoreboard players add #score_0 value 4096
execute if score #ghost_tunnel_1 value matches 0 run scoreboard players add #score_1 value 4096
execute if score #ghost_tunnel_2 value matches 0 run scoreboard players add #score_2 value 4096
execute if score #ghost_tunnel_3 value matches 0 run scoreboard players add #score_3 value 4096

execute if score #ghost_tunnel_0 value matches 1 if score #power_pellet_tunnel_0 value matches 1 run scoreboard players add #score_0 value 2048
execute if score #ghost_tunnel_1 value matches 1 if score #power_pellet_tunnel_1 value matches 1 run scoreboard players add #score_1 value 2048
execute if score #ghost_tunnel_2 value matches 1 if score #power_pellet_tunnel_2 value matches 1 run scoreboard players add #score_2 value 2048
execute if score #ghost_tunnel_3 value matches 1 if score #power_pellet_tunnel_3 value matches 1 run scoreboard players add #score_3 value 2048



# Ghost proximity

execute if score #ghost_proximity value matches 0..1 run function pacman:gameplay/phase_4/bot/enabled/direction/pacman/intersection/ghost_proximity/none
execute if score #ghost_proximity value matches 0002 run function pacman:gameplay/phase_4/bot/enabled/direction/pacman/intersection/ghost_proximity/near
execute if score #ghost_proximity value matches 0003 run function pacman:gameplay/phase_4/bot/enabled/direction/pacman/intersection/ghost_proximity/close



# Randomization

scoreboard players set #input value 16
function pacman:generic/rng
scoreboard players operation #score_0 value += #output value
function pacman:generic/rng
scoreboard players operation #score_1 value += #output value
function pacman:generic/rng
scoreboard players operation #score_2 value += #output value
function pacman:generic/rng
scoreboard players operation #score_3 value += #output value







# Select direction with greatest score

scoreboard players operation #math_00 value = #score_0 value
scoreboard players operation #math_00 value > #score_1 value
scoreboard players operation #math_00 value > #score_2 value
scoreboard players operation #math_00 value > #score_3 value

scoreboard players operation #math_01 value = @s direction

execute if score #score_3 value = #math_00 value run scoreboard players set @s direction 3
execute if score #score_2 value = #math_00 value run scoreboard players set @s direction 2
execute if score #score_1 value = #math_00 value run scoreboard players set @s direction 1
execute if score #score_0 value = #math_00 value run scoreboard players set @s direction 0







# Manage turn-around boolean

scoreboard players operation #math_01 value -= @s direction
scoreboard players operation #math_01 value %= #4 value

execute if score #math_01 value matches 2 run scoreboard players add #turn_around_boolean value 1
execute unless score #math_01 value matches 2 run scoreboard players set #turn_around_boolean value 0