# Target AEC

execute if entity @s[tag=pacman] run tag @e[type=area_effect_cloud,tag=pacman,tag=game,limit=1] add target
execute if entity @s[tag=blinky] run tag @e[type=area_effect_cloud,tag=blinky,tag=game,limit=1] add target
execute if entity @s[tag=pinky ] run tag @e[type=area_effect_cloud,tag=pinky ,tag=game,limit=1] add target
execute if entity @s[tag=inky  ] run tag @e[type=area_effect_cloud,tag=inky  ,tag=game,limit=1] add target
execute if entity @s[tag=clyde ] run tag @e[type=area_effect_cloud,tag=clyde ,tag=game,limit=1] add target







# Align to grid

scoreboard players set #grid_boolean value 0
execute at @s if block ~ 0 ~ black_concrete run scoreboard players set #grid_boolean value 1

execute if score #grid_boolean value matches 1 as @e[type=area_effect_cloud,tag=target,limit=1] at @s run function pacman:gameplay/phase_4/bot/enabled/grid/non_path/main







# Update direction

scoreboard players set #boolean value 0
execute if score @s x = @s x_previous if score @s z = @s z_previous run scoreboard players set #boolean value 1
execute if score #boolean value matches 0 run function pacman:gameplay/phase_4/bot/enabled/direction/main







# Push position

scoreboard players operation @s x_previous = @s x
scoreboard players operation @s z_previous = @s z







# Move

scoreboard players operation #math_00 value = @s direction
scoreboard players operation #math_01 value = @s movement_speed

execute if score #grid_boolean value matches 0 as @e[type=area_effect_cloud,tag=target,limit=1] at @s run function pacman:gameplay/phase_4/bot/enabled/move







# Warp functionality

tag @s add target
execute as @e[type=area_effect_cloud,tag=target,limit=1] at @s run function pacman:gameplay/phase_4/bot/enabled/warp
tag @s remove target







# Remove target tag

tag @e[type=area_effect_cloud] remove target







# Rotate

execute if score #first_person value matches 0 at @s run teleport @s ~ ~ ~ 0 0
execute if score #first_person value matches 1 if score #player value matches 1 at @s[scores={direction=0}] run teleport @s ~ ~ ~ 000 0
execute if score #first_person value matches 1 if score #player value matches 1 at @s[scores={direction=1}] run teleport @s ~ ~ ~ -90 0
execute if score #first_person value matches 1 if score #player value matches 1 at @s[scores={direction=2}] run teleport @s ~ ~ ~ 180 0
execute if score #first_person value matches 1 if score #player value matches 1 at @s[scores={direction=3}] run teleport @s ~ ~ ~ 090 0